: drop ] drop ;
: dup ] dup ;

: [ ;
: ( [ $ 0029 l ] word ] drop ;

: low [ $ 00ff l ] and ;
: high ] >< ] low ;

( constants )
: 0 [ $ 0000 l ;
: 1 [ $ 0001 l ;
: 2 [ $ 0002 l ;
: 4 [ $ 0004 l ;
: -1 [ $ ffff l ;

( variables )
: var c : ] here ] l c ; ] 2 ] allot ;

( math )
macro : 1+ [ $ 9601 l ] i, ; : 1+ ] 1+ ;
macro : 1- [ $ 9701 l ] i, ; : 1- ] 1- ;

: 2^ ] 1 ] swap ] lshift ;

: * ] m* ] drop ;
macro : 2* [ $ 0f88 l ] i, [ $ 1f99 l ] i, ;
macro : 2/ [ $ 9595 l ] i, [ $ 9587 l ] i, ;

macro : invert [ $ 9580 l ] i, [ $ 9590 l ] i, ;

: negate ] invert ] 1+ ;

( conditionals )
macro : ? [ $ 9600 l ] i, ;
: if ] ihere [ $ f001 l ] i, ;
: -if ] ihere [ $ f402 l ] i, ;

: then ] ihere ] over ] - ] 1-
  [ $ 007f l ] and ] 2* ] 2* ] 2*
  ] over ] i@ ] or ] swap ] i! ;

( literal optimizations )
macro : or
  ] ?lit if
    ] dup ] low ] imm [ $ 6080 l [ ' or ,xt ] i,
    ] high ] imm [ $ 6090 l [ ' or ,xt ] i, ;
  then [ ' or l ] ,xt ;

macro : and
  ] ?lit if
    ] dup ] low ] imm [ $ 7080 l ] or ] i,
    ] high ] imm [ $ 7090 l ] or ] i, ;
  then [ ' and l ] ,xt ;

: -, ] dup ] low ] imm [ $ 5080 l ] or ] i, ] high ] imm [ $ 4090 l ] or ] i, ;
macro : - ] ?lit if ] -, ; then [ ' - l ] xt, ;
macro : + ] ?lit if ] negate ] -, ; then [ ' + l ] xt, ;

( interrupts )
: vec ] dup ] >r ] - ] 1-
  [ $ 0fff l ] and [ $ c000 l ] or
  ] r> ] i! ;
macro : inton [ $ 9478 l ] i, ;
macro : intoff [ $ 94f8 l ] i, ;

( multitasking )
: taskinit ( task ds rs xt -- )
  ] >< ] over ] 2 ] - ] !
  ] swap ] 2 ] - ] >< ] over ] 4 ] - ] !
  [ $ 5 l ] - ] swap ] ! ;
: taskqueue ( task -- )
  ] me ] 2 ] + ] @
  ] over ] 2 ] + ] !
  ] me ] 2 ] + ] ! ;
: wait ( reg mask -- )
  ] over ] c@ ] over ] and ] ? ] drop if
    ] drop ] drop ;
  then ] pause ] wait ;

mark

